Subject: bug#10620: closed (Re: bug#10620: Improper handling of newline characters)

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 27 Jan 2012 10:29:02 +0000

Your bug report

#10620: Improper handling of newline characters

which was filed against the coreutils package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
10620: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=10620
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#10620: Improper handling of newline characters
From: Pádraig Brady <[email-masked]>
To: Philippe Grégoire <[email-masked]>
Cc: [email-masked]
Date: Fri, 27 Jan 2012 10:28:01 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

On 01/27/2012 04:16 AM, Philippe Grégoire wrote:
> Hi,
> 
> I am using GNU coreutils 8.5 (I know it is not the newest, thanks
> Debian) and found an issue regarding the handling of newline characters.
> 
> If I type the command '/usr/bin/printf "hi\b"', the result is as
> expected -- "h" without a newline character. However, if I type
> '/usr/bin/printf "hi\b\n"', the result is "hi" followed by a newline.
> The newline character seems to force a buffer flush without respecting
> what precedes it. The behavior is the same no matter what precedes the
> backspace character and the number of backspace characters -- try "a\b\b\n".
> 
> Now testing the same strings using the C version of printf (libc6
> 2.11.2), I get the same result. As such, I am wondering if it is the
> result of a bug in the terminal driver; sorry to bother, I discovered it
> using. I tested with bash, dash, konsole, xterm and a linux console with
> the same results.
> 
> By the way, I get the same behavior using "/bin/echo -e" with and
> without the -n flag".
> 
> 
> Thank you for your work!

The confusion here is that \b moves back, but does not delete.
So \b chars right before \n are ineffectual.
The reason it seems to work when no newline is entered,
is because the shell is writing the prompt over the backspaced chars.

I think this is illustrative:

$ env printf "hi\b\ba\n"
ai

cheers,
Pádraig.

Subject: Improper handling of newline characters
From: Philippe Grégoire <[email-masked]>
To: [email-masked]
Date: Thu, 26 Jan 2012 23:16:04 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,

I am using GNU coreutils 8.5 (I know it is not the newest, thanks
Debian) and found an issue regarding the handling of newline characters.

If I type the command '/usr/bin/printf "hi\b"', the result is as
expected -- "h" without a newline character. However, if I type
'/usr/bin/printf "hi\b\n"', the result is "hi" followed by a newline.
The newline character seems to force a buffer flush without respecting
what precedes it. The behavior is the same no matter what precedes the
backspace character and the number of backspace characters -- try "a\b\b\n".

Now testing the same strings using the C version of printf (libc6
2.11.2), I get the same result. As such, I am wondering if it is the
result of a bug in the terminal driver; sorry to bother, I discovered it
using. I tested with bash, dash, konsole, xterm and a linux console with
the same results.

By the way, I get the same behavior using "/bin/echo -e" with and
without the -n flag".

Thank you for your work!

Philippe